struct kpixmap{
	long width, height;
	Pixmap pmap;
};

struct kpixmap oper_a, oper_i, left_a, left_i, base_a, base_i;


struct shead{
	char magic[4];
	unsigned long ver;
	void *param;
	void *buttons;
	void *bitmaps;
};

#pragma pack(push,1)
typedef struct {
	long height;
	short rmargin;
	short lmargin;
	short bmargin;
	short tmargin;
	long ilcolor;
	long olcolor;
	long fcolor;
	long dtpfsize;
}sparams;
#pragma pack(pop)

void read_skin(){
	unsigned int fsize;
	unsigned char *skin, *tmp, *tmp2;
	sparams header;
	int i, j;
	long height, width;
	FILE *f;
	fprintf(stderr, "Loading skin data\n");
	f = fopen("default.bin", "rb");
	fseek(f, 0, SEEK_END);
	fsize = ftell(f);
	fseek(f, 0, SEEK_SET);
	skin = (unsigned char*)malloc(fsize);
	fread(skin, fsize, 1, f);
	if(*(long*)(skin) == 0x4e494b53)fprintf(stderr, "Magic Ok\n");
	fprintf(stderr, "Version: 0x%08x\n", *(long*)(skin + 4));

	// params
	tmp = skin + *(long*)(skin + 8);
	fprintf(stderr, "Params offset: 0x%08x\n", tmp - skin);
	memcpy(&header, tmp, sizeof(header));

	fprintf(stderr, "skin height: 0x%08x\n\
right margin: 0x%04x\n\
left margin: 0x%04x\n\
bottom margin: 0x%04x\n\
top margin: 0x%04x\n\
inner line color: 0x%08x\n\
outer line color: 0x%08x\n\
frame color: 0x%08x\n\
dtp file size: 0x%08x\n",
	header.height, header.rmargin, header.lmargin, header.bmargin, header.tmargin, header.ilcolor, header.olcolor, header.fcolor, header.dtpfsize);

	// buttons

	// bitmaps
	tmp = skin + *(long*)(skin + 16);

	for(i = 0; *(long*)(tmp + i); i+=8){
		printf("0x%08x%08x -> ", *(long*)(tmp + i + 4), *(long*)(tmp + i));

		width = *(long*)(skin + *(long*)(tmp + i + 4));
		height = *(long*)(skin + 4 +*(long*)(tmp + i + 4));

		printf("width: %d height: %d\n", width, height);

		tmp2 = (unsigned char *)malloc(width * height * 3);
		memcpy(tmp2, (skin + 8 +*(long*)(tmp + i + 4)), width * height * 3);

		switch(*(long*)(tmp + i)){
		case 0x1:
			left_i.pmap = CreatePixmapFromRAW(display, window, tmp2, width, height);
			left_i.width = width;
			left_i.height = height;
			break;

		case 0x10001:
			left_a.pmap = CreatePixmapFromRAW(display, window, tmp2, width, height);
			left_a.width = width;
			left_a.height = height;
			break;
		
		case 0x2:
			oper_i.pmap = CreatePixmapFromRAW(display, window, tmp2, width, height);
			oper_i.width = width;
			oper_i.height = height;
			break;

		case 0x10002:
			oper_a.pmap = CreatePixmapFromRAW(display, window, tmp2, width, height);
			oper_a.width = width;
			oper_a.height = height;
			break;

		case 0x3:
			base_i.pmap = CreatePixmapFromRAW(display, window, tmp2, width, height);
			base_i.width = width;
			base_i.height = height;
			break;

		case 0x10003:
			base_a.pmap = CreatePixmapFromRAW(display, window, tmp2, width, height);
			base_a.width = width;
			base_a.height = height;
			break;

		}

	}
	
// ;   dw = bitmap kind (1 = left, 2 = oper, 3 = base)
// ;   dw = bitmap type (1 = active, 0 = inactive)
// ;   dd @ bitmap
// ;   ... etc for all bitmaps
// ;   dd 0 (end of bitmaps list)


	fclose(f);
}
