#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <asm/ucontext.h>
#include <asm/ldt.h>

#include "z.h"

#define stack_size	32708

int	klbr_sp;

struct  user_desc ldt_code = {
	1,			// .entry_number
	(unsigned int)base, 	// .base_addr
	1,			// .limit ; // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	1,			// .seg_32bit
	MODIFY_LDT_CONTENTS_CODE, // .contents
	0, 			// .read_exec_only
	1, 			// .limit_in_pages
	0, 			// .seg_not_present
	1			// .useable
};

struct  user_desc ldt_data = {2, (unsigned int)base, 1, 1, MODIFY_LDT_CONTENTS_DATA, 0, 1, 0, 1};
struct sigaltstack altstack  = {NULL, 0, 0}; // ss_sp, ss_flags, ss_size
struct sigaction sigsegv_action;

void OnSigSegv(int sig, siginfo_t* info, struct ucontext* puc){
	if(puc->uc_mcontext.cs != 0x0f)exit(0);
	
	if(puc->uc_mcontext.eax == 4){
		puts(&base[puc->uc_mcontext.ecx]);
	}else{
		printf("EAX : 0x%08x EBX : 0x%08x ECX : 0x%08x\n", puc->uc_mcontext.eax, puc->uc_mcontext.ebx, puc->uc_mcontext.ecx);
		printf("EDX : 0x%08x ESI : 0x%08x EDI : 0x%08x\n", puc->uc_mcontext.edx, puc->uc_mcontext.esi, puc->uc_mcontext.edi);
		printf("EBP : 0x%08x EIP : 0x%08x ESP : 0x%08x\n", puc->uc_mcontext.ebp, puc->uc_mcontext.eip, puc->uc_mcontext.esp);
		printf("Flags : 0x%08x CS: 0x%04x\n", puc->uc_mcontext.eflags, puc->uc_mcontext.cs);
		printf("DATA: 0x%04x\n", *(short*)(base + puc->uc_mcontext.eip));
		exit(0);
	}
	(puc->uc_mcontext).eip += 2;
};


int main(){
	klbr_sp = 1000;
	modify_ldt(1, &ldt_code, sizeof(ldt_code));
	modify_ldt(1, &ldt_data, sizeof(ldt_data));
	
	altstack.ss_sp = malloc(stack_size);
	altstack.ss_size = stack_size;
	sigaltstack(&altstack, NULL);

	sigsegv_action.sa_sigaction = NULL;
	sigsegv_action.sa_handler = (void (*)(int))OnSigSegv;
	sigemptyset(&sigsegv_action.sa_mask);
	sigsegv_action.sa_flags = SA_ONSTACK | SA_SIGINFO;
	sigaction(SIGSEGV, &sigsegv_action, NULL);
	
	__asm__ __volatile__ (
		"mov klbr_sp, %ebx\n"
		"mov $0x17, %ax\n"
		"mov %ax, %ds\n"
		"mov %ax, %es\n"
		"mov %ax, %ss\n"
		"mov %ebx, %esp\n"
		"jmp $0x0f, $0x08\n"
        );
	return 0;
}
